pro ssw_service, query, qfile=qfile, $
   foreground=foreground , background=background
;+
;   Name: ssw_service
;
;   Purpose: manage SSW/WWW services
;
;   Input Paramters:
;      query - POST or GET query stream
;
;   Keyword Parameters:
;      qfile - POST or GET query file (alternative to query input)
;      foreground - if set, run in foreground (override QUERY setting)
;      background - if set, background (add to query pending 
;
;   History:
;      25-October-2001 - 
;-


set_logenv,'path_http','/net/diapason/www1/htdocs/solarsoft/ssw_client'
set_logenv,'top_http','http://www.lmsal.com/solarsoft/ssw_client'

case 1 of 
   data_chk(qfile,/string): begin 
      info=url_decode(qfile=qfile)
      break_file,qfile,ll,pp,ff,ee,vv
      
      outdir=concat_dir('$path_http','data')
      help,outdir,http_names(outdir)
   endcase
   data_chk(query,/string): info=query
   else: begin 
      box_message,'Require QUERY string or QUERY file
      return
   endcase
endcase

background=gt_tagval(info,/ssw_service_execution,missing='') eq 'background' $
   or keyword_set(background)
foreground=keyword_set(foreground) or (1-background)

service=gt_tagval(info,/SSW_SERVICE,missing='')
service=strlowcase(ssw_strsplit(service,' ',/head))

s1=gt_tagval(info,/param1_sample,missing='')
s2=gt_tagval(info,/param2_sample,missing='')

p1=([gt_tagval(info,/param1,missing=''),s1])(s1 ne '')

p2=([gt_tagval(info,/param2,missing=''),s2])(s2 ne '')
 
extra=gt_tagval(info,/EXTRA,missing='')

break_url,p1,server1,path1,files1,ftp=ftp,http=http
break_url,p2,server2,path2,files2,ftp=ftp,http=http

post2=gt_tagval(info,/URL_DESTINATION,missing='')

help,service,background,p1,p2

if background then begin
   box_message,'background task'
   outfile=concat_dir('$path_http','www_pending')
   file_append,outfile,rd_tfile(qfile),/new
endif else begin 
   box_message,'foreground'
   case service(0) of 
      'plot_map': begin
          ssw_url2data,p1,index,data
          if data_chk(index,/struct) then begin 
             set_plot,'z'
             index2map,index,data,map
             estring='plot_map,map' + (["",',' + extra])(extra ne '') 
             estat=execute(estring)
             ofile=concat_dir(outdir,ff+'.png')
             zbuff2file2,ofile
             qfile=http_names(ofile)
          endif
      endcase

      'coalign': begin
      endcase

      'goes': begin
          set_plot,'z'
          estring="plot_goes,'"+ p1+"','" +p2+"'"
             estat=execute(estring)
             ofile=concat_dir(outdir,ff+'.png')
             zbuff2file2,ofile
             qfile=http_names(ofile)

      endcase

      'plot_ace': begin 
      endcase

      else: begin
      endcase
   endcase
   if post2 ne '' then begin
      box_message,'Posting result...'
      ssw_post_query,post2,qfile, status=status      
   endif
endelse

return
end
